#include "stdafx.h"
#include "rebuhtah.h"
#include "rebuhtahDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CRebuhtahDlg::CRebuhtahDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRebuhtahDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRebuhtahDlg)
	m_text = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ZLWICON);
}

void CRebuhtahDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRebuhtahDlg)
	DDX_Text(pDX, IDC_TEXT, m_text);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRebuhtahDlg, CDialog)
	//{{AFX_MSG_MAP(CRebuhtahDlg)
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDJA, OnButtonJA)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CRebuhtahDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	SetWindowText("ZLW-IMA Reboot");//hier nur Taskbar Text

	UINT timer = 0;
	m_text="Soll der Rechner rebootet werden?";
	LPTSTR sParameter = GetCommandLine();

	if(strstr(sParameter, "-timer1m") != NULL) timer = 60000*1;
	if(strstr(sParameter, "-timer5m") != NULL) timer = 60000*5;
	if(strstr(sParameter, "-timer10s") != NULL) timer = 10000;	//10 Sekunden
	if(strstr(sParameter, "-timer30s") != NULL) timer = 30000;	//30 Sekunden
	
	if (timer > 0)
	{
		UINT nTimer = SetTimer (1337, timer, NULL);
		if (nTimer == 0) AfxMessageBox("Timer konnte nicht gestartet werden");
		
		reinterpret_cast<CButton *>(GetDlgItem(IDJA))->EnableWindow(false);
		reinterpret_cast<CButton *>(GetDlgItem(IDCANCEL))->EnableWindow(false);
		
		char buffer[10];
		_itoa(timer/1000, buffer, 10 );
		m_text="Der Rechner wird in " + (CString)buffer + " Sekunden rebootet ...";
	}
	UpdateData(FALSE);
	
	SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_NOSENDCHANGING);	// immer im Vordergrund
	return TRUE;
}


HCURSOR CRebuhtahDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRebuhtahDlg::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent == 1337) DoReboot();
	else CDialog::OnTimer(nIDEvent);
}

void CRebuhtahDlg::DoReboot()
{
	KillTimer(1337);
	//Sicherer Reboot, stammt aus der MSDN
	HANDLE hToken; 
	TOKEN_PRIVILEGES tkp; 
 
    OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken);
    LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &tkp.Privileges[0].Luid); 
 
    tkp.PrivilegeCount = 1;
    tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED; 
 
    AdjustTokenPrivileges(hToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0); 
	ExitWindowsEx(EWX_REBOOT | EWX_FORCE, 0);
}

void CRebuhtahDlg::OnCancel() 
{
	MessageBox("Damit die neu-installierten Programme korrekt funktionieren, sollte der Rechner einmal rebooten.\n\nBitte starten Sie neu, bevor sie die neu installierten Programme benutzen.", "ZLW-IMA Rechnerteam", MB_SYSTEMMODAL|MB_ICONEXCLAMATION);
	CDialog::OnCancel();
}

void CRebuhtahDlg::OnButtonJA() 
{
	DoReboot();
}